#lang errortrace racket

(define foo "foo")

(define (point x y z)
  (list x y z))

(define p1 (point 1 2 3))

(define (second l)
  (first (rest l)))

(define (third l)
  (first (rest (rest l))))

(define (point-x p)
  (first p))
(define (point-y p)
  (second p))

(define (point-z p)
  (third p))


;; (point-x p1)
;; (point-y p1)
;; (point-z p1)



(define (point? x)
  (and
    (list? x)
    (= (length x) 3)
  )
)
#|
(point? (point 1 2 3)) ; #t
(point? 10) ; #f
(point? (list 1 2)) ; #f
(point? (list 2 3 4 5)); #f
(point? "foo") ; #f|#

(define code (quote (define x 10)))

; (list? code) ; #t
; (length code) ; 3
(first code) ; 'define
(second code) ; 'x
(third code) ; 10

(define (define-basic? data)
  (and
    (list? data)
    (equal? (length data) 3)
    (equal? (first data) 'define)
  )
)






